/**
 * @file cdefs.h
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * @version 0.1
 * @date 2024-04-25
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#ifndef CDEFS_H
#define CDEFS_H

#undef __BEGIN_DECLS
#undef __END_DECLS
#ifdef __cplusplus
     # define __BEGIN_DECLS extern "C" {
     # define __END_DECLS }
#else
     # define __BEGIN_DECLS /* empty */
     # define __END_DECLS /* empty */
#endif

#ifdef __cplusplus
    #define __THROW throw()
#else
    #define __THROW
#endif

/* Convenience macro to test the version of gcc.
   Use like this:
   #if __GNUC_PREREQ (2,8)
   ... code requiring gcc 2.8 or later ...
   #endif
   Note: only works for GCC 2.0 and later, because __GNUC_MINOR__ was
   added in 2.0.  */
#if defined __GNUC__ && defined __GNUC_MINOR__
# define __GNUC_PREREQ(maj, min) \
	((__GNUC__ << 16) + __GNUC_MINOR__ >= ((maj) << 16) + (min))
#else
# define __GNUC_PREREQ(maj, min) 0
#endif

#endif
