/**
 * @file intsafe.h
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Определения целочисленных типов в стиле Windows.
 * @version 0.1
 * @date 2024-04-21
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#ifndef INTSAFE_H
#define INTSAFE_H

#include <limits.h>

//
// описания типов
//
typedef char                    CHAR;
typedef signed char             INT8;
typedef unsigned char           UCHAR;
typedef unsigned char           UINT8;
typedef unsigned char           BYTE;
typedef short                   SHORT;
typedef signed short            INT16;
typedef unsigned short          USHORT;
typedef unsigned short          UINT16;
typedef unsigned short          WORD;
typedef int                     INT;
typedef signed int              INT32;
typedef unsigned int            UINT;
typedef unsigned int            UINT32;
typedef long                    LONG;
typedef unsigned long           ULONG;
typedef unsigned long           DWORD;
typedef long long int           LONGLONG;
typedef long long int           LONG64;
typedef long long int           INT64;
typedef unsigned long long int  ULONGLONG;
typedef unsigned long long int  DWORDLONG;
typedef unsigned long long int  ULONG64;
typedef unsigned long long int  DWORD64;
typedef unsigned long long int  UINT64;

#endif // INTSAFE_H
