/**
 * @file limits.h
 * @brief Стандартная библиотека контроллера "Сатурн-PLC"
 * @version 0.1
 * @date 2024-03-09
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#ifndef LIMITS_H
#define LIMITS_H

// тип данных char
#define CHAR_BIT            8
#define MB_LEN_MAX          2

#define SCHAR_MIN           (-128)
#define SCHAR_MAX           127
#define UCHAR_MAX           255

#define CHAR_MIN            SCHAR_MIN
#define CHAR_MAX            SCHAR_MAX

// тип данных int
#define INT_MAX             2147483647
#define INT_MIN             (-INT_MAX-1)
#define UINT_MAX            0xFFFFFFFF

// тип данных short
#define SHRT_MAX            32767
#define SHRT_MIN            (-SHRT_MAX-1)
#define USHRT_MAX           0xFFFF

// тип данных long
#define LONG_MAX            2147483647L
#define LONG_MIN            (-LONG_MAX-1)
#define ULONG_MAX           0xFFFFFFFFUL

// POSIX wants this
#define SSIZE_MAX           LONG_MAX

// тип данных long long
#define LLONG_MAX           9223372036854775807LL
#define LLONG_MIN           (-LLONG_MAX - 1)
#define ULLONG_MAX          (2ULL * LLONG_MAX + 1)

#define LONG_LONG_MAX       9223372036854775807LL
#define LONG_LONG_MIN       (-LONG_LONG_MAX-1)
#define ULONG_LONG_MAX      (2ULL * LONG_LONG_MAX + 1)

// MSVC compatibility
#define _I64_MIN            LONG_LONG_MIN
#define _I64_MAX            LONG_LONG_MAX
#define _UI64_MAX           ULONG_LONG_MAX

#endif
