/**
 * @file syscallp.h
 * @brief Стандартная библиотека контроллера "Сатурн-PLC"
 * Прототипы функций __syscall
 * @version 0.1
 * @date 2024-04-09
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */
#ifndef SYSCALLP_H
#define SYSCALLP_H

#include <cdefs.h>
#include <stdint.h>
#include <stddef.h>
#include "../includes/syscall.h"

__BEGIN_DECLS

long  __internal_syscall_invoke1(long n, long _a0);

long  __internal_syscall_invoke2(long n, long _a0, long _a1);

long  __internal_syscall(long n, long _a0, long _a1, long _a2, long _a3, long _a4, long _a5);

float __internal_syscallf_invoke1(long n, float _fa0);

float __internal_syscallf_invoke2(long n, float _fa0, float _fa1);

float __internal_syscallf_invoke6(long n, float _fa0, float _fa1, float _fa2, float _fa3, float _fa4, float _fa5);

double __internal_dfp_invoke1(long n, double x);

double __internal_dfp_invoke2(long n, double x, double y);

__END_DECLS

#endif
