#=========================================================================
# crt0.S : Точка входа программы пользователя Saturn-PLC
#=========================================================================

    .section .text

_start:
    .global _start
    .type   _start, @function

    .equ SYSCALL_RTINITSCR, 8
    .equ SYSCALL_RTINITMEM, 10

# точка входа
    j _init_mem
    
    # идентификатор ПО: "Saturn Plc RiscV"
    .ascii "sprv"
    # версия RTL
    .word 0

# инициализация глобальных переменных
_init_mem:
    #
    # __internal_syscall(SYSCALL_RTINITMEM, (long)&_data_start, (long)&_sdata_start, (long)&_sdata_size, (long)&_bss_start, (long)&_bss_size, (long)&_heap_start);
    #
    lui     a0, %hi(_data_start)
    addi    a0, a0, %lo(_data_start)
    
    lui     a1, %hi(_sdata_start)
    addi    a1, a1, %lo(_sdata_start)
    
    lui     a2, %hi(_sdata_size)
    addi    a2, a2, %lo(_sdata_size)
    
    lui     a3, %hi(_bss_start)
    addi    a3, a3, %lo(_bss_start)

    lui     a4, %hi(_bss_size)
    addi    a4, a4, %lo(_bss_size)

    lui     a5, %hi(_heap_start)
    addi    a5, a5, %lo(_heap_start)
    #
    li      a7, SYSCALL_RTINITMEM
    ecall

# передача указателя на описание экрана
    #
    # __internal_syscall(SYSCALL_RTINITSCR, (long)&_sat_screen, 0, 0, 0, 0, 0);
    #
    lui     a0, %hi(_sat_screen)
    addi    a0, a0, %lo(_sat_screen)
    #
    li      a7, SYSCALL_RTINITSCR
    ecall

_restart:
    call    main
# при выходе из main завершаем работу
    j       _start

# если результат !=0, то переходим на адрес 0 (остановка выполнения)
    # bnez    a0, _start
# если результат ==0, то повторный вызов main()
    # j       _restart

    .size  _start, .-_start
    .end
