/**
 * @file 1251toutf8.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функция преобразования CP1251 -> UTF8.
 * @version 0.1
 * @date 2024-05-07
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <iconv.h>

/**
 * @brief Преобразование строки из кодировки cp1251 в UTF8.
 * Функция возвращает количество байт занятых в буфере utf8 (включая завершающий символ 0).
 * При ошибке функция возвращает значение 0. Ошибка может быть вызвана недостаточным размером буфера utf8 или некорректными значениями параметров.
 * @param cp1251 Исходная строка в кодировке cp1251.
 * @param utf8 Буфер для строки в кодировке UTF8.
 * @param maxLen Размер буфера для строки UTF8.
 * @return int 
 */
int cp1251_to_utf8(char *cp1251, char *utf8, int maxLen) {
    return char_string_to_UTF8(charCP_1251, cp1251, utf8, maxLen);
}
