@echo off

setlocal EnableDelayedExpansion

set PREFIX=%RISCV_INSTALL_PATH%\bin\riscv32-unknown-elf

set CFLAGS=-nostdlib -nostdinc -ffreestanding -O1 -march=rv32imaf -mabi=ilp32f -Wall -Werror -I../include -I../../emulator/includes

if "%1"=="debug" (
    set CFLAGS=-g -ggdb !CFLAGS!
)

REM наладка malloc()
REM #define MALLOC_DEBUG    1

del /s *.o >nul 2>&1
del /s libsatstd.a >nul 2>&1

set SRC=^
syscalls.s ^
app\mqtt.c ^
app\pgsql.c ^
app\lanmon.c ^
app\satpid.c ^
app\satsun.c ^
app\merc230.c ^
app\weather.c ^
app\weather_text.c ^
http\httpsrv.c ^
http\httpurl.c ^
http\httpreq.c ^
sat\satparams.c ^
sat\fastmem.c ^
sat\netvars.c ^
sat\satkbd.c ^
sat\satmem.c ^
sat\satmio.c ^
sat\satscr.c ^
sat\menu.c ^
cjson\cjson.c ^
cjson\cjson_add.c ^
cjson\cjson_crt.c ^
cjson\cjson_dup.c ^
cjson\cjson_ins.c ^
cjson\cjson_min.c ^
cjson\cjson_del.c ^
cjson\cjson_path.c ^
cjson\cjson_print.c ^
wctype\iswalnum.c ^
wctype\iswalpha.c ^
wctype\iswblank.c ^
wctype\iswcntrl.c ^
wctype\iswdigit.c ^
wctype\iswgraph.c ^
wctype\iswupper.c ^
wctype\iswlower.c ^
wctype\iswprint.c ^
wctype\iswspace.c ^
wctype\iswpunct.c ^
wctype\towlower.c ^
wctype\towupper.c ^
wctype\iswxdigit.c ^
utfstr\charlenutf8.c ^
utfstr\strcistrutf8.c ^
utfstr\strncicmputf8.c ^
utfstr\utf8strmakelwrutf8str.c ^
utfstr\utf8strmakeuprutf8str.c ^
utfstr\utf8toutf32.c ^
utfstr\utf32toutf8.c ^
utfstr\strcatutf32.c ^
utfstr\strcpyutf32.c ^
utfstr\strlenutf32.c ^
utfstr\strncmputf32.c ^
utfstr\strtolwrutf32.c ^
utfstr\strtouprutf32.c ^
utfstr\strcistrutf32.c ^
utfstr\strncicmputf32.c ^
stdio\stdio.c ^
stdio\printf.c ^
stdio\sscanf.c ^
stdio\unistd.c ^
stdio\serial.c ^
stdio\satsock.c ^
stdlib\abs.c ^
stdlib\atof.c ^
stdlib\atoi.c ^
stdlib\ctype.c ^
stdlib\malloc.c ^
stdlib\threads.c ^
stdlib\bsearch.c ^
stdlib\errno.c ^
stdlib\qsort.c ^
stdlib\rand.c ^
stdlib\strtod.c ^
stdlib\strtol.c ^
stdlib\strtoul.c ^
stdlib\regexp.c ^
math\mathd.c ^
math\mathf.c ^
math\fpde64.c ^
math\arith64.c ^
time\time.c ^
time\tzset.c ^
time\clock.c ^
time\mktime.c ^
time\gettick.c ^
time\gmttime.c ^
time\dttounix.c ^
time\unixtodt.c ^
time\localtime.c ^
crc\crc8.c ^
crc\crc16.c ^
crc\crc32.c ^
crc\crc64.c ^
crc\crcccitt.c ^
crypto\md5.c ^
crypto\rc4.c ^
crypto\aes.c ^
crypto\sha1.c ^
crypto\sha256.c ^
crypto\base64.c ^
crypto\blowfish.c ^
crypto\hw_rand.c ^
crypto\arcfour.c ^
string\memset_s.S ^
string\memmove_s.S ^
string\memchr.c ^
string\memcmp.c ^
string\memmove.c ^
string\memset.c ^
string\memswap.c ^
string\strcat.c ^
string\strchr.c ^
string\strcmp.c ^
string\strcpy.c ^
string\strtok.c ^
string\strdup.c ^
string\strlen.c ^
string\strcspn.c ^
string\strlcat.c ^
string\strlcpy.c ^
string\strncat.c ^
string\strncmp.c ^
string\strncpy.c ^
string\strndup.c ^
string\strnlen.c ^
string\strpbrk.c ^
string\strrchr.c ^
string\strrev.c ^
string\strspn.c ^
string\strstr.c ^
modbus\modbus.c ^
modbus\modbus_data.c ^
modbus\modbus_serv.c ^
iconv\cp852.c ^
iconv\cp895.c ^
iconv\cp1250.c ^
iconv\cp1251.c ^
iconv\cp1252.c ^
iconv\cp1253.c ^
iconv\cp1254.c ^
iconv\cp1255.c ^
iconv\cp1256.c ^
iconv\cp1257.c ^
iconv\cp1258.c ^
iconv\cpkoi8r.c ^
iconv\iso8859_1.c ^
iconv\iso8859_2.c ^
iconv\iso8859_3.c ^
iconv\iso8859_4.c ^
iconv\iso8859_5.c ^
iconv\iso8859_6.c ^
iconv\iso8859_7.c ^
iconv\iso8859_8.c ^
iconv\iso8859_9.c ^
iconv\iso8859_13.c ^
iconv\iso8859_15.c ^
iconv\utf8to1251.c ^
iconv\1251toutf8.c ^
iconv\isocptoutf8.c ^
soft-fp128\addtf3.c ^
soft-fp128\addtf3.c ^
soft-fp128\divtf3.c ^
soft-fp128\eqtf2.c  ^
soft-fp128\extenddftf2.c ^
soft-fp128\extendsftf2.c ^
soft-fp128\fixtfsi.c ^
soft-fp128\fixunstfsi.c ^
soft-fp128\floatsitf.c ^
soft-fp128\floatunsitf.c ^
soft-fp128\getf2.c ^
soft-fp128\letf2.c ^
soft-fp128\multf3.c ^
soft-fp128\subtf3.c ^
soft-fp128\trunctfdf2.c ^
soft-fp128\trunctfsf2.c ^
stdbit\stdc_bit_ceil_uc.c ^
stdbit\stdc_bit_ceil_ui.c ^
stdbit\stdc_bit_ceil_ul.c ^
stdbit\stdc_bit_ceil_ull.c ^
stdbit\stdc_bit_ceil_us.c ^
stdbit\stdc_bit_floor_uc.c ^
stdbit\stdc_bit_floor_ui.c ^
stdbit\stdc_bit_floor_ul.c ^
stdbit\stdc_bit_floor_ull.c ^
stdbit\stdc_bit_floor_us.c ^
stdbit\stdc_bit_width_uc.c ^
stdbit\stdc_bit_width_ui.c ^
stdbit\stdc_bit_width_ul.c ^
stdbit\stdc_bit_width_ull.c ^
stdbit\stdc_bit_width_us.c ^
stdbit\stdc_count_ones_uc.c ^
stdbit\stdc_count_ones_ui.c ^
stdbit\stdc_count_ones_ul.c ^
stdbit\stdc_count_ones_ull.c ^
stdbit\stdc_count_ones_us.c ^
stdbit\stdc_count_zeros_uc.c ^
stdbit\stdc_count_zeros_ui.c ^
stdbit\stdc_count_zeros_ul.c ^
stdbit\stdc_count_zeros_ull.c ^
stdbit\stdc_count_zeros_us.c ^
stdbit\stdc_first_leading_one_uc.c ^
stdbit\stdc_first_leading_one_ui.c ^
stdbit\stdc_first_leading_one_ul.c ^
stdbit\stdc_first_leading_one_ull.c ^
stdbit\stdc_first_leading_one_us.c ^
stdbit\stdc_first_leading_zero_uc.c ^
stdbit\stdc_first_leading_zero_ui.c ^
stdbit\stdc_first_leading_zero_ul.c ^
stdbit\stdc_first_leading_zero_ull.c ^
stdbit\stdc_first_leading_zero_us.c ^
stdbit\stdc_first_trailing_one_uc.c ^
stdbit\stdc_first_trailing_one_ui.c ^
stdbit\stdc_first_trailing_one_ul.c ^
stdbit\stdc_first_trailing_one_ull.c ^
stdbit\stdc_first_trailing_one_us.c ^
stdbit\stdc_first_trailing_zero_uc.c ^
stdbit\stdc_first_trailing_zero_ui.c ^
stdbit\stdc_first_trailing_zero_ul.c ^
stdbit\stdc_first_trailing_zero_ull.c ^
stdbit\stdc_first_trailing_zero_us.c ^
stdbit\stdc_has_single_bit_uc.c ^
stdbit\stdc_has_single_bit_ui.c ^
stdbit\stdc_has_single_bit_ul.c ^
stdbit\stdc_has_single_bit_ull.c ^
stdbit\stdc_has_single_bit_us.c ^
stdbit\stdc_leading_ones_uc.c ^
stdbit\stdc_leading_ones_ui.c ^
stdbit\stdc_leading_ones_ul.c ^
stdbit\stdc_leading_ones_ull.c ^
stdbit\stdc_leading_ones_us.c ^
stdbit\stdc_leading_zeros_uc.c ^
stdbit\stdc_leading_zeros_ui.c ^
stdbit\stdc_leading_zeros_ul.c ^
stdbit\stdc_leading_zeros_ull.c ^
stdbit\stdc_leading_zeros_us.c ^
stdbit\stdc_trailing_ones_uc.c ^
stdbit\stdc_trailing_ones_ui.c ^
stdbit\stdc_trailing_ones_ul.c ^
stdbit\stdc_trailing_ones_ull.c ^
stdbit\stdc_trailing_ones_us.c ^
stdbit\stdc_trailing_zeros_uc.c ^
stdbit\stdc_trailing_zeros_ui.c ^
stdbit\stdc_trailing_zeros_ul.c ^
stdbit\stdc_trailing_zeros_ull.c ^
stdbit\stdc_trailing_zeros_us.c

echo Compiling crt0.s...
%PREFIX%-gcc %CFLAGS% -c crt0.s     || goto :error

set OBJS=
for %%f in (%SRC%) do (
    echo Compiling %%f...
    %PREFIX%-gcc %CFLAGS% -c %%f    || goto :error
    set OBJS=!OBJS! %%~nf.o
)

echo;
echo Creating static library...
%PREFIX%-ar.exe qs libsatstd.a %OBJS% >nul 2>&1 || goto :error

echo Copying library...
copy libsatstd.a %SAT_SDK_PATH%\lib >nul
copy crt0.o %SAT_SDK_PATH%\lib      >nul
copy satplc.ld %SAT_SDK_PATH%\lib   >nul

echo Copying headers...
copy ..\include\*.h %SAT_SDK_PATH%\include  >nul
copy ..\..\emulator\includes\sysdefs.h %SAT_SDK_PATH%\include   >nul

echo;
echo Build completed successfully!

:error
@exit /b %errorlevel%
