/**
 * @file atoi.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC"
 * @version 0.1
 * @date 2024-04-19
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include <ctype.h>
#include <stdlib.h>

/**
 * @brief Преобразование строки в целое число
 * 
 * @param str Указатель на строку
 * @return int 
 */
int atoi(const char *str) {
    int acc = 0;

    for(; str && isdigit(*str); ++str) {
        acc *= 10;
        acc += *str - 0x30;
    }
    return acc;
}
