#ifndef _ASM_RISCV_ASM_H
#define _ASM_RISCV_ASM_H

#define __ASM_STR(x)	x

#define __REG_SEL(a, b)	__ASM_STR(b)

#define REG_L			__REG_SEL(ld, lw)
#define REG_S			__REG_SEL(sd, sw)
#define REG_SC			__REG_SEL(sc.d, sc.w)
#define REG_AMOSWAP_AQ	__REG_SEL(amoswap.d.aq, amoswap.w.aq)
#define REG_ASM			__REG_SEL(.dword, .word)
#define SZREG			__REG_SEL(8, 4)
#define LGREG			__REG_SEL(3, 2)

/* Some toolchains use other characters (e.g. '`') to mark new line in macro */
#ifndef ASM_NL
#define ASM_NL		 ;
#endif

/* SYM_FUNC_START -- use for global functions */
#ifndef SYM_FUNC_START
#define SYM_FUNC_START(name)			\
	.global name;						\
	.type   name, @function;			\
	name:
#endif

/*
 * SYM_FUNC_END -- the end of SYM_FUNC_START_LOCAL, SYM_FUNC_START,
 * SYM_FUNC_START_WEAK, ...
 */
#ifndef SYM_FUNC_END
#define SYM_FUNC_END(name)					\
	.size  name, .-name;
#endif

/* SYM_ALIAS -- use only if you have to */
#ifndef SYM_ALIAS
#define SYM_ALIAS(alias, name, linkage)		\
	linkage(alias) ASM_NL					\
	.set alias, name ASM_NL
#endif

#endif
