/**
 * @file string.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками и памятью.
 * @version 0.1
 * @date 2024-04-18
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "string.h"

#define USE_ASM_MEMSET

#ifdef USE_ASM_MEMSET
void *__memset (void *dest, int val, size_t len);

void *memset (void *dest, int val, size_t len) {
    return __memset(dest, val, len);
}
#else
void *memset (void *dest, int val, size_t len) {
    unsigned char *ptr = (unsigned char*)dest;
    while (len-- > 0) *ptr++ = val;
    return dest;
}
#endif
