/**
 * @file string.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками и памятью.
 * @version 0.1
 * @date 2024-04-18
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "string.h"

size_t strlcat(char *to, const char *from, size_t size) {
    char *d = to;
    const char *s = from;
    size_t n = size;
    size_t dlen;
    // Find the end of dst and adjust bytes left but don't go past end
    while (n-- != 0 && *d != '\0') d++;
    dlen = d - to;
    n = size - dlen;
    if (n == 0) return(dlen + strlen(s));
    while (*s != '\0') {
        if (n != 1) {
            *d++ = *s;
            n--;
        }
        s++;
    }
    *d = '\0';
    return(dlen + (s - from));  // count does not include NUL
}
