/**
 * @file string.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками и памятью.
 * @version 0.1
 * @date 2024-04-18
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "string.h"

size_t strlcpy(char *to, const char *from, size_t size) {
    char *d = to;
    const char *s = from;
    size_t n = size;
    // Copy as many bytes as will fit
    if (n != 0) {
        while (--n != 0) {
            if ((*d++ = *s++) == '\0')
                break;
        }
    }
    // Not enough room in dst, add NUL and traverse rest of src
    if (n == 0) {
        if (size != 0) *d = '\0';
        while (*s++) ;
    }
    return(s - from - 1);
}
