/**
 * @file string.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками и памятью.
 * @version 0.1
 * @date 2024-04-18
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "string.h"

char *strncpy(char *to, const char *from, size_t size) {
    if (size != 0) {
        char *d = to;
        const char *s = from;
        do {
            if ((*d++ = *s++) == 0) {
                // NUL pad the remaining n-1 bytes
                while (--size != 0) *d++ = 0;
                break;
            }
        } while (--size != 0);
    }
    return to;
}
