/**
 * @file string.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками и памятью.
 * @version 0.1
 * @date 2024-04-18
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "stdlib.h"
#include "string.h"

char *strndup(const char*  s, size_t n) {
    size_t slen = (size_t)strlen(s);
    int len  = slen < n ? slen : n;
    char *copy = malloc(len+1);
    if (copy) {
        memcpy( copy, s, len );
        copy[len] = 0;
    }
    return copy;
}
