#=========================================================================
# syscalls.S : Системные вызовы
#=========================================================================

    .section .text

# // один аргумент INT
# // long __internal_syscall_invoke1(long n, long _a0);
__internal_syscall_invoke1:
    .global __internal_syscall_invoke1
    .type   __internal_syscall_invoke1, @function
    mv a7, a0
    mv a0, a1
    ecall
    ret

# // два аргумента INT
# // long __internal_syscall_invoke2(long n, long _a0, long _a1);
__internal_syscall_invoke2:
    .global __internal_syscall_invoke2
    .type   __internal_syscall_invoke2, @function
    mv a7, a0
    mv a0, a1
    mv a1, a2
    ecall
    ret

# // шесть аргументов INT
# // long __internal_syscall(long n, long _a0, long _a1, long _a2, long _a3, long _a4, long _a5);
__internal_syscall:
    .global __internal_syscall
    .type   __internal_syscall, @function
    mv a7, a0
    mv a0, a1
    mv a1, a2
    mv a2, a3
    mv a3, a4
    mv a4, a5
    mv a5, a6
    ecall
    ret

# один аргумент FP:     float __internal_syscallf_invoke1(long n, float _fa0);
__internal_syscallf_invoke1:
# два аргумента FP:     float __internal_syscallf_invoke2(long n, float _fa0, float _fa1);
__internal_syscallf_invoke2:
# шесть аргументов FP:  float __internal_syscallf_invoke6(long n, float _fa0, float _fa1, float _fa2, float _fa3, float _fa4, float _fa5);
__internal_syscallf_invoke6:
    .global __internal_syscallf_invoke1
    .type   __internal_syscallf_invoke1, @function
    .global __internal_syscallf_invoke2
    .type   __internal_syscallf_invoke2, @function
    .global __internal_syscallf_invoke6
    .type   __internal_syscallf_invoke6, @function
    mv a7, a0
    ecall
    ret

# один аргумент LONG, результат FLOAT
__internal_syscall_wrapper_fi:
    .global __internal_syscall_wrapper_fi
    .type   __internal_syscall_wrapper_fi, @function
    mv a7, a0
    mv a0, a1
    ecall
    fmv.w.x fa0, a0             # a0 -> fa0
    ret

# два аргумента LONG и FLOAT, результат VOID
__internal_syscall_wrapper_vif:
    .global __internal_syscall_wrapper_vif
    .type   __internal_syscall_wrapper_vif, @function
    mv a7, a0
    mv a0, a1
    fmv.x.w a1, fa0             # fa0 -> a1
    ecall
    ret

# попытка входа в критическую секцию
# void __critical_section_enter(void *addr)
__critical_section_enter:
    .global __critical_section_enter
    .type   __critical_section_enter, @function
    li t0, 1                    # t0 = 1
cs_again:
    amoswap.w.aq t0, t0, (a0)
    bnez t0, cs_again
    ret

# выход из критической секции
# void __critical_section_leave(void *addr)
__critical_section_leave:
    .global __critical_section_leave
    .type   __critical_section_leave, @function
    amoswap.w.rl x0, x0, (a0)
    ret

# атомарный обмен значениями
# long __atomic_swap(void *addr, long val)
__atomic_swap:
    .global __atomic_swap
    .type   __atomic_swap, @function
    amoswap.w.aq a0, a1, (a0)       # (a0) -> a0, a1 -> (a0)
    ret

.end
