/**
 * @file clock.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с временем.
 * @version 0.1
 * @date 2024-03-10
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "syscallp.h"
#include "time.h"

/**
 * @brief Возвращает время, затраченное процессором на выполнение программы, или -1, если оно неизвестно.
 * Размерность возвращаемого значения определяется при помощи константы CLOCKS_PER_SEC,
 * которая задаёт количество единиц значения времени в одной секунде.
 * 
 * @return clock_t 
 */
clock_t clock(void) {
    return __internal_syscall_invoke1(SYSCALL_CLOCK, 0);
}
