/**
 * @file dttounix.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с временем.
 * @version 0.1
 * @date 2024-05-15
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include <time.h>
#include "tdatetime.h"

/**
 * @brief Преобразует время в формате TDateTime (Delphi) в time_t.
 * @param dt Время в формате TDateTime.
 * @return time_t 
 */
time_t DateTimeToUnix(TDateTime dt) {
    return (dt - UNIX_EPOCH) * SECS_PER_DAY;
}

