/**
 * @file gettick.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с временем.
 * @version 0.1
 * @date 2024-03-10
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "stdint.h"
#include "syscallp.h"

#include "time.h"

/**
 * @brief Получение времени, прошедшего с момента запуска контроллера, в миллисекундах.
 * 
 * @return uint32_t 
 */
uint32_t GetTickCount(void) {
    return (uint32_t)__internal_syscall_invoke1(SYSCALL_GetTickCount, 0);
}
