/**
 * @file time.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с временем.
 * @version 0.1
 * @date 2024-03-10
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 * 
 */

#include "syscallp.h"
#include "time.h"

/**
 * @brief Возвращает текущее календарное время или −1, если это время не известно.
 * Если указатель tp не равен NULL, то возвращаемое значение записывается также и в *tp.
 * 
 * @param timer 
 * @return time_t 
 */
time_t time(time_t *timer) {
    time_t t = __internal_syscall_invoke1(SYSCALL_TIME, 0);
    //
    if(timer) *timer = t;
    return t;
}
