/**
 * @file unixtodt.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с временем.
 * @version 0.1
 * @date 2024-05-15
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <time.h>
#include "tdatetime.h"

/**
 * @brief Преобразует время в формате time_t в формат TDateTime (Delphi).
 * @param tv Время в формате time_t
 * @return TDateTime 
 */
TDateTime UnixToDateTime(time_t tv) {
    return (UNIX_EPOCH + tv / SECS_PER_DAY);
}
