/**
 * @file mbslen.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками в кодировках UTF8/16/32.
 * @version 0.1
 * @date 2024-05-11
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <wchar.h>

/**
 * @brief Возвращает длину строки UTF8 в символах.
 * @param pmbc Указатель на строку.
 * @return size_t 
 */
size_t mbslen(const char* pmbc) {
    size_t ztUtf8 = 0;
    size_t ztNumUtf8Chars = 0;

    while (pmbc[ztUtf8] != 0) {
        ztNumUtf8Chars++;
        //
        if ((pmbc[ztUtf8] & 0b10000000) == 0) ztUtf8 += 1;
        else 
        if ((pmbc[ztUtf8] & 0b11100000) == 0b11000000) ztUtf8 += 2;
        else 
        if ((pmbc[ztUtf8] & 0b11110000) == 0b11100000) ztUtf8 += 3;
        else ztUtf8 += 4;
    }
    return ztNumUtf8Chars;
}
