/**
 * @file wcscpy.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками в кодировках UTF8/16/32.
 * @version 0.1
 * @date 2024-05-11
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <string.h>
#include <wchar.h>

/**
 * @brief Копирование строки UTF32.
 * @param dest Указатель на буфер назначения.
 * @param src Указатель на исходную строку.
 * @return wchar_t* 
 */
wchar_t* wcscpy(wchar_t* dest, const wchar_t* src) {
    return (wchar_t *)memcpy(dest, src, (wcslen(src) + 1)*sizeof(wchar_t));
}
