/**
 * @file wcsupr.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы со строками в кодировках UTF8/16/32.
 * @version 0.1
 * @date 2024-05-11
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <wctype.h>

#include <wchar.h>

/**
 * @brief Перевод строки UTF32 в верхний регистр.
 * Функция переводит символы строки pwcs в верхний регистр.
 * @param pwcs Указатель на строку UTF32.
 * @return wchar_t* Указатель на строку pwcs.
 */
wchar_t* wcsupr(wchar_t* pwcs) {
    wchar_t* p = pwcs;
    if (pwcs && *pwcs) {
        while(*p) {
            *p = towupper(*p);
            p++;
        }
    }
    return pwcs;
}
