/**
 * @file iswblank.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с символами wchar_t.
 * @version 0.1
 * @date 2024-05-14
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <stddef.h>
#include <wctype.h>

/**
 * @brief Функция проверяет, является ли символ "пустым" широким символом.
 * @param c 
 * @return int 
 */
int iswblank(wchar_t c) {
    return (c == 0x0009 || c == 0x0020 || c == 0x1680 || c == 0x180e || (c >= 0x2000 && c <= 0x2006) || (c >= 0x2008 && c <= 0x200a) || c == 0x205f || c == 0x3000);
}
