/**
 * @file iswblank.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с символами wchar_t.
 * @version 0.1
 * @date 2024-05-14
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <stddef.h>
#include <wctype.h>

/**
 * @brief Функция проверяет, является ли символ широким управляющим символом.
 * @param c 
 * @return int 
 */
int iswcntrl(wchar_t c) {
    return ((c >= 0x0000 && c <= 0x001f) || (c >= 0x007f && c <= 0x009f) || c == 0x2028 || c == 0x2029);
}
