/**
 * @file iswdigit.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с символами wchar_t.
 * @version 0.1
 * @date 2024-05-14
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <stddef.h>
#include <wctype.h>

/**
 * @brief Функция возвращает ненулевое значение, если c является цифрой.
 * @param c 
 * @return int 
 */
int iswdigit(wchar_t c) {
    return (c >= (wint_t)'0' && c <= (wint_t)'9');
}
