/**
 * @file iswpunct.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с символами wchar_t.
 * @version 0.1
 * @date 2024-05-14
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <stddef.h>
#include <wctype.h>

/**
 * @brief Функция проверяет, является ли данный символ широким символом пунктуации или символьным широким символом.
 * @param c 
 * @return int 
 */
int iswpunct(wchar_t c) {
    return (!iswalnum (c) && iswgraph (c));
}
