/**
 * @file iswxdigit.c
 * @brief Стандартная библиотека контроллера "Сатурн-PLC".
 * Функции работы с символами wchar_t.
 * @version 0.1
 * @date 2024-05-14
 * 
 * @copyright Copyright (C) 2024, ООО "МНПП Сатурн"
 */

#include <stddef.h>
#include <wctype.h>

/**
 * @brief Функция проверяет, является ли символ широким символом в виде шестнадцатеричного числа.
 * @param c 
 * @return int 
 */
int iswxdigit(wchar_t c) {
    return ((c >= (wint_t)'0' && c <= (wint_t)'9') || (c >= (wint_t)'a' && c <= (wint_t)'f') || (c >= (wint_t)'A' && c <= (wint_t)'F'));
}
